

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Lime

#property indicator_maximum  1                               //      
#property indicator_minimum -1                               //      
#property indicator_level1 0.0                               //  N    ,  N  1  8 
#property indicator_levelcolor White                         //    
#property indicator_levelwidth 1                             //    

#property indicator_width1 2
#property indicator_width2 2


/*
***************************************************************************************   
               
            . 
***************************************************************************************   
*/

//---- input parameters
extern   int       T_Life_CDL        =  3;                         //    5  
                                                                    
extern   bool      Img_UP_DW         =  true;                      //        
extern   color     Color_UP_D        =  Red;                       //     
                                                                  
extern   bool      Img_DW_UP         =  true;                      //        
extern   color     Color_DW_UP       =  Lime;                      //     
                                                                    
                                                                          
         double    Price_UP_1        =  0;                         //   ()   
         int       Num_bar_UP_1      =  0;                         //    ()    
         int       Num_bar_UP_1_1    =  0;
         double    Price_UP_2        =  0;                         //   ()   
         int       Num_bar_UP_2      =  0;                         //    ( )  
         
         double    Price_DW_1        =  0;                         //   ()   
         int       Num_bar_DW_1      =  0;                         //    ()   
         int       Num_bar_DW_1_1    =  0;
         double    Price_DW_2        =  0;                         //   ()    
         int       Num_bar_DW_2      =  0;                         //    ()   
         
         double    UP_T              =  0;                         //  
         double    DW_T              =  0;                         //   
                    
         double    Line_UP_DW        =  0;                         //         
         double    Line_DW_UP        =  0;                         //         
         double    Line_UP_DW_Old    =  0;                         
         double    Line_DW_UP_Old    =  0; 
         double    Line_UP_DW_Old_2  =  0;
         double    Line_DW_UP_Old_2  =  0;
                   

//---- buffers                                                  
         double UP[];                                              // 
         double DW[];                                              //  
         double UP_Trend[];                                        // 
         double DW_Trend[];                                        // 



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {  
 
//---- indicators

     SetIndexStyle  (0, DRAW_HISTOGRAM, STYLE_SOLID, 2);
     SetIndexBuffer (0,UP_Trend);
     SetIndexStyle  (1, DRAW_HISTOGRAM, STYLE_SOLID, 2);
     SetIndexBuffer (1,DW_Trend);
     SetIndexBuffer (2,UP);
     SetIndexBuffer (3,DW);

     SetIndexEmptyValue(2,0.0);
     SetIndexEmptyValue(3,0.0);   
     
     IndicatorShortName(" 5-  FOR_EX");
     IndicatorDigits(Digits-5);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   fObjDeleteByPrefix(WindowExpertName());//   , ,   
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
    int limit=Bars-IndicatorCounted();
   /* ArrayResize (UP,Bars);
    ArrayResize (DW,Bars);*/
    for(int i=limit-1;i>=0;i--){
        int p=i+3;
        UP[p]=0;
        DW[p]=0;
        UP_T =  0;
        DW_T =  0; 
        Price_UP_1     =  0;                     
        Num_bar_UP_1   =  0; 
        Num_bar_UP_1_1 =  0;                       
        Price_UP_2     =  0;                       
        Num_bar_UP_2   =  0;                         
         
        Price_DW_1     =  0;                         
        Num_bar_DW_1   =  0; 
        Num_bar_DW_1_1 =  0;                        
        Price_DW_2     =  0;                         
        Num_bar_DW_2   =  0;  
        
        Line_UP_DW     =  0; 
        Line_DW_UP     =  0; 
        
        int hb=fGetIndexHighBars(i);
        int lb=fGetIndexLowBars(i);
        int s=0;
        if(hb==p){
          UP[p]=High[p];
        }
        //               
        int size_up = ArrayRange(UP,0);
        for (s=i;s<=size_up;s++){
            Price_UP_1 = UP[s];
            Num_bar_UP_1 = s;
            Num_bar_UP_1_1 = Num_bar_UP_1;
            
            if (Price_UP_1 > 0){
               for (s=Num_bar_UP_1_1+1; s<=size_up;s++){
                   Price_UP_2 = UP[s];
                   Num_bar_UP_2 = s;
                   if (Price_UP_2 > 0 && (Num_bar_UP_2 - Num_bar_UP_1_1 >= T_Life_CDL+1)){
                      break;
                   }
                   if (Price_UP_2 > 0){
                      Num_bar_UP_1 = s; 
                   }  
               }
               break; 
            }     
        }
        
        s=0;
        if(lb==p){
          DW[p]=Low[p];  
        }
        //        
        int size_dw = ArrayRange(DW,0);
        for (s=i;s<=size_dw;s++){
            Price_DW_1 = DW[s];
            Num_bar_DW_1 = s;
            Num_bar_DW_1_1 = Num_bar_DW_1;
            
            if (Price_DW_1 > 0){
               for (s=Num_bar_DW_1_1+1; s<=size_dw;s++){
                   Price_DW_2 = DW[s];
                   Num_bar_DW_2 = s;
                   if (Price_DW_2 > 0 && (Num_bar_DW_2 - Num_bar_DW_1_1 >= T_Life_CDL+1)){
                      break;
                   } 
                   if (Price_DW_2 > 0){
                      Num_bar_DW_1 = s; 
                   }  
               }
               break; 
            }     
        }                   
          
        
        //          
        if (Price_UP_1 > 0 && Price_UP_2 > 0 ){
           if (Price_UP_1 <=  Price_UP_2){ 
              Line_UP_DW = fGetLineValue_y3(Num_bar_UP_1,High[Num_bar_UP_1],Num_bar_UP_2,High[Num_bar_UP_2],i);   
              Line_UP_DW_Old = fGetLineValue_y3(Num_bar_UP_1,High[Num_bar_UP_1],Num_bar_UP_2,High[Num_bar_UP_2],Num_bar_UP_1-2);   
              if(Img_UP_DW){
                if (!ObjectMove(WindowExpertName()+"_Up_"+Time[Num_bar_UP_2]+"_"+Time[Num_bar_UP_1-3],0,Time[i],Line_UP_DW)){ 
                   fObjTrendLine(WindowExpertName()+"_Up_"+Time[Num_bar_UP_2]+"_"+Time[i],Time[i],Line_UP_DW,Time[Num_bar_UP_2],High[Num_bar_UP_2],false,Color_UP_D,1,0,0,false);        
                }              
              }              
           }            
        }
        
        
        //          
        if (Price_DW_1 > 0 && Price_DW_2 > 0 ){
           if (Price_DW_1 >=  Price_DW_2){ 
              Line_DW_UP = fGetLineValue_y3(Num_bar_DW_1,Low[Num_bar_DW_1],Num_bar_DW_2,Low[Num_bar_DW_2],i);
              Line_DW_UP_Old = fGetLineValue_y3(Num_bar_DW_1,Low[Num_bar_DW_1],Num_bar_DW_2,Low[Num_bar_DW_2],Num_bar_DW_1-2);       
              if(Img_DW_UP){  
                 if (!ObjectMove(WindowExpertName()+"_DW_"+Time[Num_bar_DW_2]+"_"+Time[Num_bar_DW_1-3],0,Time[i],Line_DW_UP)){ 
                    fObjTrendLine(WindowExpertName()+"_DW_"+Time[Num_bar_DW_2]+"_"+Time[i],Time[i],Line_DW_UP,Time[Num_bar_DW_2],Low[Num_bar_DW_2],false,Color_DW_UP,1,0,0,false);        
                 }             
              }            
           }            
        }
     

//***************************************        ********************************************
        // 1.     (  1      
        //       )
        
        for (int u=i+1;u<Num_bar_UP_1-2;u++){
            if (UP_Trend[u] > 0){
               Line_UP_DW_Old_2 = Line_UP_DW_Old;
            }
        }
        
        if (Price_UP_1 <=  Price_UP_2){
           if (Line_UP_DW_Old != Line_UP_DW_Old_2){             
                if (Close[i] > Line_UP_DW){
                UP_T =  1;
                DW_T =  0;
                }
             } 
        }
        
        // 2.    
        for (int d=i+1;d<Num_bar_DW_1-2;d++){
            if (DW_Trend[d] < 0){
               Line_DW_UP_Old_2 = Line_DW_UP_Old;
            }
        }
        
        if (Price_DW_1 >=  Price_DW_2){
           if (Line_DW_UP_Old != Line_DW_UP_Old_2){             
              if (Close[i] < Line_DW_UP){
                 UP_T =  0;
                 DW_T =  -1;
                 Print ("DW_T_",DW_T,"_i_",i);
              }
           } 
        }

        
//***************************************   **********************************
    UP_Trend[i] = UP_T;  
    DW_Trend[i] = DW_T;  
    //Alert("Num_bar_UP_1_1: ",Num_bar_UP_1_1);
    }
    return(0);
    }




void fObjTrendLine(
   string aObjectName,  // 1 
   datetime aTime_1,    // 2  1
   double aPrice_1,     // 3  1
   datetime aTime_2,    // 4  2
   double aPrice_2,     // 5  2
   bool aRay=false,     // 6 
   color aColor=Red,    // 7 
   int aWidth=1,        // 8 
   int aWindowNumber=0, // 9 
   int aStyle=0,        // 10 0-STYLE_SOLID, 1-STYLE_DASH, 2-STYLE_DOT, 3-STYLE_DASHDOT, 4-STYLE_DASHDOTDOT
   bool aBack=false     // 11 
   ){
      if(ObjectFind(aObjectName)!=aWindowNumber){  
         ObjectCreate(aObjectName,OBJ_TREND,aWindowNumber,aTime_1,aPrice_1,aTime_2,aPrice_2);
      }      
   ObjectSet(aObjectName,OBJPROP_TIME1,aTime_1);
   ObjectSet(aObjectName,OBJPROP_PRICE1,aPrice_1);   
   ObjectSet(aObjectName,OBJPROP_TIME2,aTime_2);       
   ObjectSet(aObjectName,OBJPROP_PRICE2,aPrice_2); 
   ObjectSet(aObjectName,OBJPROP_RAY,aRay);     
   ObjectSet(aObjectName,OBJPROP_COLOR,aColor);
   ObjectSet(aObjectName,OBJPROP_WIDTH,aWidth);
   ObjectSet(aObjectName,OBJPROP_BACK,aBack);
   ObjectSet(aObjectName,OBJPROP_STYLE,aStyle);                
}

double fGetLineValue_y3(double x1,double y1,double x2,double y2,double x3){
   double d=x2-x1;
   if(d==0)return(-1);
   return(y1+(x3-x1)*(y2-y1)/d);
}

void fObjDeleteByPrefix(string aPrefix){
   for(int i=ObjectsTotal()-1;i>=0;i--){
      if(StringFind(ObjectName(i),aPrefix,0)==0){
         ObjectDelete(ObjectName(i));
      }
   }
}

int fGetIndexHighBars(int aStart){
   if (High[aStart+3] > High[aStart+5] && High[aStart+3] >= High[aStart+4] && High[aStart+3] >= High[aStart+2] && High[aStart+3] > High[aStart+1]) 
      int iIndexBar = aStart+3; 
   return(iIndexBar);
}

int fGetIndexLowBars(int aStart){
   if (Low[aStart+3] < Low[aStart+5] && Low[aStart+3] <= Low[aStart+4] && Low[aStart+3] <= Low[aStart+2] && Low[aStart+3] < Low[aStart+1]) 
      int iIndexBar = aStart+3; 
   return(iIndexBar);
}